<template>
    <Dialog :visible.sync="dialogVisible" :style="{width: '500px'}" header="User Details" :modal="true" :closable=false>
        <div class="p-cardialog-content" v-if="user">
            <div class="p-grid p-fluid">
                <div class="p-col-4" v-if="lbBtn === 'Add'"><label for="username">Username</label></div>
                <div class="p-col-8" v-if="lbBtn === 'Add'">
                    <InputText id="username" v-model="user.username" autocomplete="off"/>
                </div>
                <div class="p-col-4"><label for="email">Email</label></div>
                <div class="p-col-8">
                    <InputText id="email" v-model="user.email" autocomplete="off"/>
                </div>

                <div class="p-col-4"><label for="fullName">Full name</label></div>
                <div class="p-col-8">
                    <InputText id="fullName" v-model="user.fullName" autocomplete="off"/>
                </div>

                <div class="p-col-4"><label for="birthday">Birthday</label></div>
                <div class="p-col-8">
                    <Calendar id="birthday" v-model="user.dob" dateFormat="dd/mm/yy"/>
                </div>

                <div class="p-col-4"><label for="type">Is administrator</label></div>
                <div class="p-col-8" style="text-align: left">
                    <Checkbox id="type" v-model="checked" :binary="true"/>
                </div>
            </div>
        </div>

        <template #footer>
            <Button :label="lbBtn" icon="pi pi-times" class="p-button-info" @click="doUpdateOrCreateUser()"/>
            <Button label="Cancel" icon="pi pi-check" class="p-button-secondary" @click="close()"/>
        </template>
    </Dialog>
</template>

<script>
    import {mapActions} from 'vuex'

    export default {
        name: 'DialogEditUser',
        props: ['dialogVisible', 'user', 'lbBtn'],
        data() {
            return {
                checked: false
            }
        },
        computed: {},
        watch: {
            user: function () {
                this.checked = this.user.isAdmin == 1;
            }
        },
        methods: {
            ...mapActions('users', {
                updateUser: 'updateUser',
                createUser: 'createUser'
            }),
            doUpdateOrCreateUser() {
                this.user.isAdmin = this.checked ? 1 : 0;
                if (this.lbBtn === 'Add')
                    this.createUser(this.user);
                else
                    this.updateUser(this.user)
            },
            close() {
                this.$emit('closeRequest');
            }
        }

    };
</script>
<style>
    .p-dialog-content {
        overflow: unset !important;
    }
</style>
